# TODO
# - tests packaged in -devel to own pkg or just rm -rf
# - pldize ha_logd initscript (look heartbeat.init?)
# - stonith-libs? pils?
Summary:	Reusable cluster components
Name:		cluster-glue
Version:	1.0.11
Release:	5
License:	GPL v2+ and LGPL v2+
Group:		Base
URL:		http://www.linux-ha.org/
Source0:	http://hg.linux-ha.org/glue/archive/glue-%{version}.tar.bz2
# Source0-md5:	7d0acd99d43edac849dc76f43cfa4c7f
Source1:	logd.service
BuildRequires:	OpenIPMI-devel
BuildRequires:	autoconf
BuildRequires:	automake
BuildRequires:	bzip2-devel
BuildRequires:	curl-devel
BuildRequires:	docbook-dtd42-xml
BuildRequires:	docbook-dtd44-xml
BuildRequires:	docbook-style-xsl
BuildRequires:	glib2-devel
BuildRequires:	libaio-devel
BuildRequires:	libltdl-devel
BuildRequires:	libnet-devel
BuildRequires:	libstdc++-devel
BuildRequires:	libtool
BuildRequires:	libuuid-devel
BuildRequires:	libxml2-devel
BuildRequires:	libxslt-progs
BuildRequires:	ncurses-devel
BuildRequires:	net-snmp-devel >= 5.4
BuildRequires:	openhpi-devel
BuildRequires:	openssl-devel
BuildRequires:	pkgconfig
BuildRequires:	python-devel
BuildRequires:	rpm-pythonprov
BuildRequires:	zlib-devel
Requires(post,preun):	/sbin/chkconfig
Requires(postun):	/usr/sbin/groupdel
Requires(postun):	/usr/sbin/userdel
Requires(pre):	/bin/id
Requires(pre):	/usr/bin/getgid
Requires(pre):	/usr/sbin/groupadd
Requires(pre):	/usr/sbin/useradd
Requires(post,preun,postun):	systemd-units
Requires:	systemd-units
Requires:	%{name}-libs = %{version}-%{release}
Requires:	perl-TimeDate
Requires:	rc-scripts
Provides:	group(haclient)
Provides:	user(hacluster)
# Directives to allow upgrade from combined heartbeat packages
Provides:	heartbeat-pils = 3.0.0-1
Obsoletes:	heartbeat-common
Obsoletes:	heartbeat-pils < 3.0.0-1
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		filterout_ld	-Wl,--as-needed

%description
A collection of common tools that are useful for writing cluster
managers such as Pacemaker. Provides a local resource manager that
understands the OCF and LSB standards, and an interface to common
STONITH devices.

%package libs
Summary:	Reusable cluster libraries
Group:		Development/Libraries
Obsoletes:	libheartbeat2

%description libs
A collection of libraries that are useful for writing cluster managers
such as Pacemaker.

%package libs-devel
Summary:	Headers and libraries for writing cluster managers
Group:		Development/Libraries
Requires:	%{name}-libs = %{version}-%{release}
Obsoletes:	libheartbeat-devel

%description libs-devel
Headers and shared libraries for a useful for writing cluster managers
such as Pacemaker.

%package stonith
Summary:	Provides an interface to Shoot The Other Node In The Head
Summary(pl.UTF-8):	Interfejs do "odstrzelenia" drugiego węzła w klastrze
Group:		Applications/System
Requires:	OpenIPMI >= 2.0.3
Provides:	heartbeat-stonith = 3.0.0-1
Obsoletes:	heartbeat-stonith < 3.0.0-1

%description stonith
Provides an interface to Shoot The Other Node In The Head.

%description stonith -l pl.UTF-8
STONITH (Shoot The Other Node In The Head) to interfejs służący do
"odstrzelenia" drugiego węzła w klastrze.

%prep
%setup -q -n Reusable-Cluster-Components-glue--glue-%{version}
sed -i -e's;#!/usr/bin/env \(python\|perl\);#!/usr/bin/\1;' \
					lib/plugins/stonith/external/*

%build
%{__libtoolize}
%{__aclocal}
%{__autoheader}
%{__automake}
%{__autoconf}
%configure \
	--with-initdir=/etc/rc.d/init.d \
	--disable-fatal-warnings \
	--with-daemon-group=haclient \
	--with-daemon-user=hacluster\
	--docdir=%{_docdir}/%{name}-%{version} \
	--disable-static
%{__make}

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT%{systemdunitdir}

%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT

find $RPM_BUILD_ROOT -name '*.la' -delete

%{__sed} -e's;@libdir@;%{_libdir};g' \
	%{SOURCE1} > $RPM_BUILD_ROOT%{systemdunitdir}/logd.service

%clean
rm -rf $RPM_BUILD_ROOT

%pre
%groupadd -g 60 haclient
%useradd -u 17 -d /var/lib/heartbeat/cores/hacluster -c "Heartbeat User" -g haclient hacluster

%post
/sbin/chkconfig --add logd
%service logd restart
%systemd_post logd.service

%preun
if [ "$1" = "0" ]; then
	%service -q logd stop
	/sbin/chkconfig --del logd
fi
%systemd_preun logd.service

%postun
if [ "$1" = "0" ]; then
	%userremove hacluster
	%groupremove haclient
fi
%systemd_reload

%post	libs -p /sbin/ldconfig
%postun	libs -p /sbin/ldconfig

%files
%defattr(644,root,root,755)
%doc AUTHORS logd/logd.cf
%attr(754,root,root) /etc/rc.d/init.d/logd
%{systemdunitdir}/logd.service

%attr(755,root,root) %{_sbindir}/ha_logger
%attr(755,root,root) %{_sbindir}/hb_report
%attr(755,root,root) %{_sbindir}/lrmadmin
%attr(755,root,root) %{_sbindir}/meatclient
%attr(755,root,root) %{_sbindir}/sbd
%attr(755,root,root) %{_sbindir}/cibsecret
%{_mandir}/man1/ha_logger.1*
%{_mandir}/man8/ha_logd.8*
%{_mandir}/man8/hb_report.8*
%{_mandir}/man8/lrmadmin.8*
%{_mandir}/man8/meatclient.8*

%dir %{_datadir}/%{name}
%attr(755,root,root) %{_datadir}/%{name}/ha_cf_support.sh
%attr(755,root,root) %{_datadir}/%{name}/openais_conf_support.sh
%attr(755,root,root) %{_datadir}/%{name}/utillib.sh
%attr(755,root,root) %{_datadir}/%{name}/combine-logs.pl
%attr(755,root,root) %{_datadir}/%{name}/ha_log.sh

%dir %{_libdir}/heartbeat/plugins/RAExec
%dir %{_libdir}/heartbeat/plugins/InterfaceMgr
%dir %{_libdir}/heartbeat/plugins/compress
%attr(755,root,root) %{_libdir}/heartbeat/lrmd
%attr(755,root,root) %{_libdir}/heartbeat/ha_logd
%attr(755,root,root) %{_libdir}/heartbeat/plugins/InterfaceMgr/generic.so
%attr(755,root,root) %{_libdir}/heartbeat/plugins/RAExec/heartbeat.so
%attr(755,root,root) %{_libdir}/heartbeat/plugins/RAExec/lsb.so
%attr(755,root,root) %{_libdir}/heartbeat/plugins/RAExec/ocf.so
%attr(755,root,root) %{_libdir}/heartbeat/plugins/compress/bz2.so
%attr(755,root,root) %{_libdir}/heartbeat/plugins/compress/zlib.so

%dir /var/lib/heartbeat
%attr(711,root,root) %dir /var/lib/heartbeat/cores
%attr(700,root,root) %dir /var/lib/heartbeat/cores/root
%attr(700,hacluster,root) %dir /var/lib/heartbeat/cores/hacluster
# we don't want any files owned by nobody
%attr(700,root,root) %dir /var/lib/heartbeat/cores/nobody

%files libs
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/liblrm.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/liblrm.so.2
%attr(755,root,root) %{_libdir}/libpils.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libpils.so.2
%attr(755,root,root) %{_libdir}/libplumb.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libplumb.so.2
%attr(755,root,root) %{_libdir}/libplumbgpl.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libplumbgpl.so.2
%attr(755,root,root) %{_libdir}/libstonith.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libstonith.so.1
%dir %{_libdir}/heartbeat
%dir %{_libdir}/heartbeat/plugins
%dir %{_includedir}/heartbeat

%files libs-devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/liblrm.so
%attr(755,root,root) %{_libdir}/libpils.so
%attr(755,root,root) %{_libdir}/libplumb.so
%attr(755,root,root) %{_libdir}/libplumbgpl.so
%attr(755,root,root) %{_libdir}/libstonith.so
%{_includedir}/clplumbing
%{_includedir}/heartbeat/*
%{_includedir}/stonith
%{_includedir}/pils

%attr(755,root,root) %{_libdir}/heartbeat/ipctest
%attr(755,root,root) %{_libdir}/heartbeat/ipctransientclient
%attr(755,root,root) %{_libdir}/heartbeat/ipctransientserver
%attr(755,root,root) %{_libdir}/heartbeat/transient-test.sh
%attr(755,root,root) %{_libdir}/heartbeat/base64_md5_test
%attr(755,root,root) %{_libdir}/heartbeat/logtest

%dir %{_libdir}/heartbeat/plugins/test
%attr(755,root,root) %{_libdir}/heartbeat/plugins/test/test.so

%dir %{_datadir}/%{name}
%dir %{_datadir}/%{name}/lrmtest
%{_datadir}/%{name}/lrmtest/README.regression
%{_datadir}/%{name}/lrmtest/defaults
%{_datadir}/%{name}/lrmtest/descriptions
%{_datadir}/%{name}/lrmtest/language
%{_datadir}/%{name}/lrmtest/lrmadmin-interface
%attr(755,root,root) %{_datadir}/%{name}/lrmtest/LRMBasicSanityCheck
%attr(755,root,root) %{_datadir}/%{name}/lrmtest/lrmregtest*
%attr(755,root,root) %{_datadir}/%{name}/lrmtest/*.sh

%dir %{_datadir}/%{name}/lrmtest/testcases
%{_datadir}/%{name}/lrmtest/testcases/BSC
%{_datadir}/%{name}/lrmtest/testcases/basicset
%{_datadir}/%{name}/lrmtest/testcases/metadata
%{_datadir}/%{name}/lrmtest/testcases/metadata.exp
%{_datadir}/%{name}/lrmtest/testcases/rscexec
%{_datadir}/%{name}/lrmtest/testcases/rscexec.exp
%{_datadir}/%{name}/lrmtest/testcases/rscmgmt
%{_datadir}/%{name}/lrmtest/testcases/rscmgmt.exp
%{_datadir}/%{name}/lrmtest/testcases/stonith
%{_datadir}/%{name}/lrmtest/testcases/stonith.exp
%attr(755,root,root) %{_datadir}/%{name}/lrmtest/testcases/*filter
%attr(755,root,root) %{_datadir}/%{name}/lrmtest/testcases/*.sh

%files stonith
%defattr(644,root,root,755)
%doc doc/stonith/README*
%attr(755,root,root) %{_sbindir}/stonith
%{_mandir}/man8/stonith.8*
%dir %{_libdir}/stonith
%dir %{_libdir}/stonith/plugins
%dir %{_libdir}/stonith/plugins/external
%attr(755,root,root) %{_libdir}/stonith/plugins/external/*
%dir %{_libdir}/stonith/plugins/stonith2
%attr(755,root,root) %{_libdir}/stonith/plugins/stonith2/*.so
%attr(755,root,root) %{_libdir}/stonith/plugins/stonith2/ribcl.py
%attr(755,root,root) %{_libdir}/stonith/plugins/xen0-ha-dom0-stonith-helper
%changelog
* Thu Dec 06 2012 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/cluster-glue.git;a=log;h=master

* Thu Dec 06 2012 Jan Rękorajski <baggins@pld-linux.org> 4079e79
- release 5 (by relup.sh)

* Wed Nov 21 2012 Jan Rękorajski <baggins@pld-linux.org> 77838a0
- release 4 (by relup.sh)

* Fri Nov 09 2012 Jacek Konieczny <j.konieczny@eggsoft.pl> 1146040
Release: 3

* Fri Nov 09 2012 Jacek Konieczny <j.konieczny@eggsoft.pl> dd8c1a5
fixed %%files entry for external stonith plugins

* Wed Oct 31 2012 Jacek Konieczny <jajcus@jajcus.net> bda2199
Fix script headers for external stoniths plugins

* Wed Oct 31 2012 Jacek Konieczny <j.konieczny@eggsoft.pl> ba2cbcb
external stonith plugins must be executable

* Tue Oct 30 2012 Jacek Konieczny <j.konieczny@eggsoft.pl> c65ec4e
systemd unit added for logd

* Tue Oct 30 2012 Jacek Konieczny <j.konieczny@eggsoft.pl> fe30380
Version: 1.0.11

* Fri Oct 26 2012 Jacek Konieczny <j.konieczny@eggsoft.pl> 12e28ae
%{_libdir}/h.. and %{_includeir}/h.. to -libs

* Wed Sep 05 2012 Jan Rękorajski <baggins@pld-linux.org> d0629c9
- release 4 (by relup.sh)

* Tue Sep 04 2012 Jan Rękorajski <baggins@pld-linux.org> 0e70e6c
- Rebuild with DB 5.3
- release 3 (by relup.sh)

* Mon Jun 04 2012 Jacek Konieczny <jajcus@pld-linux.org> 59ce45c
- fix to glib2 includes
- include stonith test cases
- Release: 2

* Thu Mar 22 2012 Mariusz Mazur <mmazur@pld-linux.org> 7afd419
- up to 1.0.9

* Mon Oct 24 2011 mguevara <mguevara@pld-linux.org> a0cd998
- up to 1.0.8, added cibsecret binary

* Tue Jul 19 2011 Mariusz Mazur <mmazur@pld-linux.org> cbfc7b7
- seems to work; rel 1; stbr

* Tue Jul 19 2011 Mariusz Mazur <mmazur@pld-linux.org> 766e6f1
- builds; rel 0.2

* Tue Jul 19 2011 Mariusz Mazur <mmazur@pld-linux.org> 88fc01c
- up to 1.0.7; rel 0.1, nfy

* Sun May 16 2010 sparky <sparky@pld-linux.org> 0f3873c
- BR: docbook-dtd42-xml
- dropped no longer needed BR: which

* Fri Apr 23 2010 Jacek Konieczny <jajcus@pld-linux.org> 2c07a66
- Version: 1.0.5 (stable)
- disable -Werror, as a warning in glib2 headers broken the build

* Wed Jan 13 2010 Elan Ruusamäe <glen@pld-linux.org> fcfe851
- strict internal deps

